/*
 * ComboBox.h, Interleaf, 16aug93 2:37pm Version 1.1.
 */

/***********************************************************
Copyright 1993 Interleaf, Inc.

Permission to use, copy, modify, and distribute this software
and its documentation for any purpose without fee is granted,
provided that the above copyright notice appear in all copies
and that both copyright notice and this permission notice appear
in supporting documentation, and that the name of Interleaf not
be used in advertising or publicly pertaining to distribution of
the software without specific written prior permission.

Interleaf makes no representation about the suitability of this
software for any purpose. It is provided "AS IS" without any
express or implied warranty. 
******************************************************************/

/*
 *  (C) Copyright 1991,1992, 1993
 *  Interleaf, Inc.
 *  Nine Hillside Avenue, Waltham, MA  02154
 *
 * ComboBox.h: 
 * 
 * Public header file for MyComboBoxWidget.
 */
#ifndef _ComboBox_h
#define _ComboBox_h

#ifndef AA
#define AA(args) ()
#endif

#include <Xm/Xm.h>

#if (XmVersion < 2000) || defined(LESSTIF_VERSION)

#define XmNarrowSize		"arrowSize"
#define XmNarrowSpacing		"arrowSpacing"
#define XmNselectedPosition	"selectedPosition"
#define XmNselectedItem		"selectedItem"
#define XmNtextField		"textField"

#define XmCArrowSize		"ArrowSize"
#define XmCArrowSpacing		"ArrowSpacing"
#define XmCSelectedPosition	"SelectedPosition"
#define XmCSelectedItem		"SelectedItem"
#define XmCTextField		"TextField"

#else

#ifdef LESSTIF_VERSION
#define XmCTextField          "TextField"
#define XmNtextField          "textField"
#endif

#endif /* XmVersion < 2000 */

#define XmRType			"Type"

#define XmNarrowType		"arrowType"
#define XmNlist			"list"
#define XmNtype			"type"
#define XmNlistFontList		"listFontList"
#define XmNpoppedUp		"poppedUp"
#define XmNupdateLabel		"updateLabel"

#define XmCArrowType		"ArrowType"
#define XmRArrowType		"ArrowType"

#define XmCList			"List"
#define XmCListFontList		"ListFontList"
#define XmCHorizontalSpacing	"HorizontalSpacing"
#define XmCPoppedUp		"PoppedUp"
#define XmCType			"Type"
#define XmCUpdateLabel		"UpdateLabel"
#define XmCVerticalSpacing	"VerticalSpacing"

/* XmNorientation defines */
#define XmLEFT		0
#define XmRIGHT		1

/* ArrowType defines */
#define XmMOTIF		0
#define XmWINDOWS	1

/* XmNtype defines */
#define XmDROP_DOWN_LIST_BOX	0
#define XmDROP_DOWN_COMBO_BOX	1

/* ComboBox callback info */
#ifndef XmNselectionCallback
# define XmNselectionCallback   "selectionCallback"
#endif

#define XmNmenuPostCallback	"menuPostCallback"
#define XmCR_SELECT	    128 /* Large #, so no collisions with XM */
#define XmCR_MENU_POST      129 /* Large #, so no collisions with XM */

typedef struct {
   int 	     reason;
   XEvent    *event;
   XmString  item_or_text;
   int       item_position;
} MyComboBoxCallbackStruct;

extern WidgetClass dtComboBoxWidgetClass;

typedef struct _MyComboBoxClassRec *MyComboBoxWidgetClass;
typedef struct _MyComboBoxRec      *MyComboBoxWidget;

/*
 * External functions which manipulate the ComboBox list of items.
 */
extern Widget MyCreateComboBox AA((Widget parent, char *name,
				   Arg *arglist, int num_args));
extern void MyComboBoxAddItem AA((MyComboBoxWidget combo, XmString item,
				  int pos, Boolean unique));
extern void MyComboBoxDeletePos AA((MyComboBoxWidget combo, int pos));
extern void MyComboBoxSetItem AA((MyComboBoxWidget combo, XmString item));
extern void MyComboBoxSelectItem AA((MyComboBoxWidget combo, XmString item));


#endif	/* _ComboBox_h */
